/*
 *   moolinklabel.h
 *
 *   Copyright (C) 2004-2006 by Yevgen Muntyan <muntyan@math.tamu.edu>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   See COPYING file that comes with this distribution.
 */

#ifndef __MOO_LINK_LABEL_H__
#define __MOO_LINK_LABEL_H__

#include <gtk/gtklabel.h>

G_BEGIN_DECLS


#define MOO_TYPE_LINK_LABEL             (moo_link_label_get_type ())
#define MOO_LINK_LABEL(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), MOO_TYPE_LINK_LABEL, MooLinkLabel))
#define MOO_LINK_LABEL_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), MOO_TYPE_LINK_LABEL, MooLinkLabelClass))
#define MOO_IS_LINK_LABEL(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MOO_TYPE_LINK_LABEL))
#define MOO_IS_LINK_LABEL_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), MOO_TYPE_LINK_LABEL))
#define MOO_LINK_LABEL_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), MOO_TYPE_LINK_LABEL, MooLinkLabelClass))

typedef struct _MooLinkLabel        MooLinkLabel;
typedef struct _MooLinkLabelPrivate MooLinkLabelPrivate;
typedef struct _MooLinkLabelClass   MooLinkLabelClass;

struct _MooLinkLabel {
    GtkLabel parent;
    MooLinkLabelPrivate *priv;
};

struct _MooLinkLabelClass {
    GtkLabelClass parent_class;

    void (*activate) (MooLinkLabel  *label,
                      const char    *url);
};


GType        moo_link_label_get_type    (void) G_GNUC_CONST;

GtkWidget   *moo_link_label_new         (const char     *text,
                                         const char     *url);

const char  *moo_link_label_get_text    (MooLinkLabel   *label);
void         moo_link_label_set_text    (MooLinkLabel   *label,
                                         const char     *text);

const char  *moo_link_label_get_url     (MooLinkLabel   *label);
void         moo_link_label_set_url     (MooLinkLabel   *label,
                                         const char     *url);


G_END_DECLS

#endif /* __MOO_LINK_LABEL_H__ */
